Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -2992,18 +2992,18 @@
        diss_t(nzt+1) = 0.0_wp
        w_comp(nzt+1) = 0.0_wp
-       
+
        DO  k = nzb+1, nzb_max_l
 
           flux_d    = flux_t(k-1)
           diss_d    = diss_t(k-1)
-          
+
           ibit11 = REAL( IBITS(advc_flags_m(k,j,i),11,1), KIND = wp )
           ibit10 = REAL( IBITS(advc_flags_m(k,j,i),10,1), KIND = wp )
           ibit9  = REAL( IBITS(advc_flags_m(k,j,i),9,1),  KIND = wp )
-          
+
           ibit14 = REAL( IBITS(advc_flags_m(k,j,i),14,1), KIND = wp )
           ibit13 = REAL( IBITS(advc_flags_m(k,j,i),13,1), KIND = wp )
           ibit12 = REAL( IBITS(advc_flags_m(k,j,i),12,1), KIND = wp )
-          
+
           ibit17 = REAL( IBITS(advc_flags_m(k,j,i),17,1), KIND = wp )
           ibit16 = REAL( IBITS(advc_flags_m(k,j,i),16,1), KIND = wp )
@@ -3013,40 +3013,40 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div = ( ( ( u_comp(k)     + gu )                                    &
-                                       * ( ibit9 + ibit10 + ibit11 )          &
-                  - ( u(k,j-1,i) + u(k,j,i) )                                 &
-                                       * (                                    &
-                        REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )  &
-                                         )                                    &
-                  ) * ddx                                                     &
-               +  ( v_comp(k)                                                 &
-                                       * ( ibit12 + ibit13 + ibit14 )         &
-                - ( v(k,j,i)     + v(k,j-1,i) )                               &
-                                       * (                                    &
-                        REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )  &
-                                         )                                    &
-                  ) * ddy                                                     &
-               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )&
-                -   w_comp(k-1) * rho_air_zw(k-1)                             &
-                                       * (                                    &
-                        REAL( IBITS(advc_flags_m(k-1,j,i),15,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k-1,j,i),16,1), KIND = wp )  &
-                      + REAL( IBITS(advc_flags_m(k-1,j,i),17,1), KIND = wp )  &
-                                         )                                    &
-                   ) * drho_air(k) * ddzw(k)                                  &
+          div = ( ( ( u_comp(k)     + gu )                                     &
+                                       * ( ibit9 + ibit10 + ibit11 )           &
+                  - ( u(k,j-1,i) + u(k,j,i) )                                  &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )   &
+                                         )                                     &
+                  ) * ddx                                                      &
+               +  ( v_comp(k)                                                  &
+                                       * ( ibit12 + ibit13 + ibit14 )          &
+                - ( v(k,j,i)     + v(k,j-1,i) )                                &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k,j-1,i),12,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),13,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k,j-1,i),14,1), KIND = wp )   &
+                                         )                                     &
+                  ) * ddy                                                      &
+               +  ( w_comp(k)   * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 ) &
+                -   w_comp(k-1) * rho_air_zw(k-1)                              &
+                                       * (                                     &
+                        REAL( IBITS(advc_flags_m(k-1,j,i),15,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),16,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_m(k-1,j,i),17,1), KIND = wp )   &
+                                         )                                     &
+                   ) * drho_air(k) * ddzw(k)                                   &
                 ) * 0.5_wp
 
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                         ( flux_r(k) + diss_r(k)                              &
-                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx      &
-                       + ( flux_n(k) + diss_n(k)                              &
-                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
-                       + ( ( flux_t(k) + diss_t(k) )                          &
-                       -   ( flux_d    + diss_d    )                          &
-                                                   ) * drho_air(k) * ddzw(k)  &
+          tend(k,j,i) = tend(k,j,i) - (                                        &
+                         ( flux_r(k) + diss_r(k)                               &
+                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx       &
+                       + ( flux_n(k) + diss_n(k)                               &
+                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy       &
+                       + ( ( flux_t(k) + diss_t(k) )                           &
+                       -   ( flux_d    + diss_d    )                           &
+                                                   ) * drho_air(k) * ddzw(k)   &
                                       ) + v(k,j,i) * div
 
@@ -3078,5 +3078,5 @@
 
        ENDDO
-       
+
        DO  k = nzb_max_l+1, nzt
 
@@ -3152,7 +3152,7 @@
        INTEGER(iwp) ::  k_pp      !< k+2 index in disretization, can be modified to avoid segmentation faults
        INTEGER(iwp) ::  k_ppp     !< k+3 index in disretization, can be modified to avoid segmentation faults
-       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms  
+       INTEGER(iwp) ::  nzb_max_l !< index indicating upper bound for order degradation of horizontal advection terms
        INTEGER(iwp) ::  tn        !< number of OpenMP thread
-       
+
        REAL(wp)    ::  ibit18  !< flag indicating 1st-order scheme along x-direction
        REAL(wp)    ::  ibit19  !< flag indicating 3rd-order scheme along x-direction
@@ -3169,5 +3169,5 @@
        REAL(wp)    ::  gu      !< Galilei-transformation velocity along x
        REAL(wp)    ::  gv      !< Galilei-transformation velocity along y
-       
+
        REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
        REAL(wp), DIMENSION(nzb:nzt+1)  ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
@@ -3180,7 +3180,7 @@
        REAL(wp), DIMENSION(nzb:nzt+1)  ::  w_comp !< advection velocity along z
 !
-!--    Used local modified copy of nzb_max (used to degrade order of 
+!--    Used local modified copy of nzb_max (used to degrade order of
 !--    discretization) at non-cyclic boundaries. Modify only at relevant points
-!--    instead of the entire subdomain. This should lead to better 
+!--    instead of the entire subdomain. This should lead to better
 !--    load balance between boundary and non-boundary PEs.
        IF( ( bc_dirichlet_l  .OR.  bc_radiation_l )  .AND.  i <= nxl + 2  .OR. &
@@ -3192,5 +3192,5 @@
           nzb_max_l = nzb_max
        END IF
-       
+
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
@@ -3205,32 +3205,32 @@
 
              v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
-             flux_s_w(k,tn) = v_comp(k) * (                                   &
-                            ( 37.0_wp * ibit23 * adv_mom_5                    &
-                         +     7.0_wp * ibit22 * adv_mom_3                    &
-                         +              ibit21 * adv_mom_1                    &
-                            ) *                                               &
-                                        ( w(k,j,i)   + w(k,j-1,i) )           &
-                     -      (  8.0_wp * ibit23 * adv_mom_5                    &
-                         +              ibit22 * adv_mom_3                    &
-                            ) *                                               &
-                                        ( w(k,j+1,i) + w(k,j-2,i) )           &
-                     +      (           ibit23 * adv_mom_5                    &
-                            ) *                                               &
-                                        ( w(k,j+2,i) + w(k,j-3,i) )           &
+             flux_s_w(k,tn) = v_comp(k) * (                                    &
+                            ( 37.0_wp * ibit23 * adv_mom_5                     &
+                         +     7.0_wp * ibit22 * adv_mom_3                     &
+                         +              ibit21 * adv_mom_1                     &
+                            ) *                                                &
+                                        ( w(k,j,i)   + w(k,j-1,i) )            &
+                     -      (  8.0_wp * ibit23 * adv_mom_5                     &
+                         +              ibit22 * adv_mom_3                     &
+                            ) *                                                &
+                                        ( w(k,j+1,i) + w(k,j-2,i) )            &
+                     +      (           ibit23 * adv_mom_5                     &
+                            ) *                                                &
+                                        ( w(k,j+2,i) + w(k,j-3,i) )            &
                                           )
 
-             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                          &
-                            ( 10.0_wp * ibit23 * adv_mom_5                    &
-                         +     3.0_wp * ibit22 * adv_mom_3                    &
-                         +              ibit21 * adv_mom_1                    &
-                            ) *                                               &
-                                        ( w(k,j,i)   - w(k,j-1,i) )           &
-                     -      (  5.0_wp * ibit23 * adv_mom_5                    &
-                         +              ibit22 * adv_mom_3                    &
-                            ) *                                               &
-                                        ( w(k,j+1,i) - w(k,j-2,i) )           &
-                     +      (           ibit23 * adv_mom_5                    &
-                            ) *                                               &
-                                        ( w(k,j+2,i) - w(k,j-3,i) )           &
+             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                           &
+                            ( 10.0_wp * ibit23 * adv_mom_5                     &
+                         +     3.0_wp * ibit22 * adv_mom_3                     &
+                         +              ibit21 * adv_mom_1                     &
+                            ) *                                                &
+                                        ( w(k,j,i)   - w(k,j-1,i) )            &
+                     -      (  5.0_wp * ibit23 * adv_mom_5                     &
+                         +              ibit22 * adv_mom_3                     &
+                            ) *                                                &
+                                        ( w(k,j+1,i) - w(k,j-2,i) )            &
+                     +      (           ibit23 * adv_mom_5                     &
+                            ) *                                                &
+                                        ( w(k,j+2,i) - w(k,j-3,i) )            &
                                                    )
 
@@ -3240,11 +3240,11 @@
 
              v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
-             flux_s_w(k,tn) = v_comp(k) * (                                   &
-                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )              &
-                         -  8.0_wp * ( w(k,j+1,i) + w(k,j-2,i) )              &
+             flux_s_w(k,tn) = v_comp(k) * (                                    &
+                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )               &
+                         -  8.0_wp * ( w(k,j+1,i) + w(k,j-2,i) )               &
                          +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
-             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                          &
-                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )              &
-                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )              &
+             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                           &
+                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )               &
+                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
                          +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
 
@@ -3263,32 +3263,32 @@
 
              u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
-             flux_l_w(k,j,tn) = u_comp(k) * (                                 &
-                             ( 37.0_wp * ibit20 * adv_mom_5                   &
-                          +     7.0_wp * ibit19 * adv_mom_3                   &
-                          +              ibit18 * adv_mom_1                   &
-                             ) *                                              &
-                                        ( w(k,j,i)   + w(k,j,i-1) )           &
-                      -      (  8.0_wp * ibit20 * adv_mom_5                   &
-                          +              ibit19 * adv_mom_3                   &
-                             ) *                                              &
-                                        ( w(k,j,i+1) + w(k,j,i-2) )           &
-                      +      (           ibit20 * adv_mom_5                   &
-                             ) *                                              &
-                                        ( w(k,j,i+2) + w(k,j,i-3) )           &
+             flux_l_w(k,j,tn) = u_comp(k) * (                                  &
+                             ( 37.0_wp * ibit20 * adv_mom_5                    &
+                          +     7.0_wp * ibit19 * adv_mom_3                    &
+                          +              ibit18 * adv_mom_1                    &
+                             ) *                                               &
+                                        ( w(k,j,i)   + w(k,j,i-1) )            &
+                      -      (  8.0_wp * ibit20 * adv_mom_5                    &
+                          +              ibit19 * adv_mom_3                    &
+                             ) *                                               &
+                                        ( w(k,j,i+1) + w(k,j,i-2) )            &
+                      +      (           ibit20 * adv_mom_5                    &
+                             ) *                                               &
+                                        ( w(k,j,i+2) + w(k,j,i-3) )            &
                                             )
 
-             diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                        &
-                             ( 10.0_wp * ibit20 * adv_mom_5                   &
-                          +     3.0_wp * ibit19 * adv_mom_3                   &
-                          +              ibit18 * adv_mom_1                   &
-                             ) *                                              &
-                                        ( w(k,j,i)   - w(k,j,i-1) )           &
-                      -      (  5.0_wp * ibit20 * adv_mom_5                   &
-                          +              ibit19 * adv_mom_3                   &
-                             ) *                                              &
-                                        ( w(k,j,i+1) - w(k,j,i-2) )           &
-                      +      (           ibit20 * adv_mom_5                   &
-                             ) *                                              &
-                                        ( w(k,j,i+2) - w(k,j,i-3) )           &
+             diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                         &
+                             ( 10.0_wp * ibit20 * adv_mom_5                    &
+                          +     3.0_wp * ibit19 * adv_mom_3                    &
+                          +              ibit18 * adv_mom_1                    &
+                             ) *                                               &
+                                        ( w(k,j,i)   - w(k,j,i-1) )            &
+                      -      (  5.0_wp * ibit20 * adv_mom_5                    &
+                          +              ibit19 * adv_mom_3                    &
+                             ) *                                               &
+                                        ( w(k,j,i+1) - w(k,j,i-2) )            &
+                      +      (           ibit20 * adv_mom_5                    &
+                             ) *                                               &
+                                        ( w(k,j,i+2) - w(k,j,i-3) )            &
                                                      )
 
@@ -3298,12 +3298,12 @@
 
              u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
-             flux_l_w(k,j,tn) = u_comp(k) * (                                 &
-                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1) )             &
-                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )             &
+             flux_l_w(k,j,tn) = u_comp(k) * (                                  &
+                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1) )              &
+                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
                           +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
-             diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                        &
-                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1) )             &
-                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )             &
-                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5 
+             diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                         &
+                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1) )              &
+                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
+                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
 
           ENDDO
@@ -3320,32 +3320,32 @@
 
           u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp(k) * (                                           &
-                     ( 37.0_wp * ibit20 * adv_mom_5                           &
-                  +     7.0_wp * ibit19 * adv_mom_3                           &
-                  +              ibit18 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+1) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit20 * adv_mom_5                           &
-                  +              ibit19 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+2) + w(k,j,i-1) )               &
-              +      (           ibit20 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+3) + w(k,j,i-2) )               &
+          flux_r(k) = u_comp(k) * (                                            &
+                     ( 37.0_wp * ibit20 * adv_mom_5                            &
+                  +     7.0_wp * ibit19 * adv_mom_3                            &
+                  +              ibit18 * adv_mom_1                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+1) + w(k,j,i)   )                &
+              -      (  8.0_wp * ibit20 * adv_mom_5                            &
+                  +              ibit19 * adv_mom_3                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+2) + w(k,j,i-1) )                &
+              +      (           ibit20 * adv_mom_5                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+3) + w(k,j,i-2) )                &
                                   )
 
-          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit20 * adv_mom_5                           &
-                  +     3.0_wp * ibit19 * adv_mom_3                           &
-                  +              ibit18 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+1) - w(k,j,i)   )               &
-              -      (  5.0_wp * ibit20 * adv_mom_5                           &
-                  +              ibit19 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+2) - w(k,j,i-1) )               &
-              +      (           ibit20 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+3) - w(k,j,i-2) )               &
+          diss_r(k) = - ABS( u_comp(k) ) * (                                   &
+                     ( 10.0_wp * ibit20 * adv_mom_5                            &
+                  +     3.0_wp * ibit19 * adv_mom_3                            &
+                  +              ibit18 * adv_mom_1                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+1) - w(k,j,i)   )                &
+              -      (  5.0_wp * ibit20 * adv_mom_5                            &
+                  +              ibit19 * adv_mom_3                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+2) - w(k,j,i-1) )                &
+              +      (           ibit20 * adv_mom_5                            &
+                     ) *                                                       &
+                                    ( w(k,j,i+3) - w(k,j,i-2) )                &
                                            )
 
@@ -3355,32 +3355,32 @@
 
           v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                     ( 37.0_wp * ibit23 * adv_mom_5                           &
-                  +     7.0_wp * ibit22 * adv_mom_3                           &
-                  +              ibit21 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j+1,i) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit23 * adv_mom_5                           &
-                  +              ibit22 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j+2,i) + w(k,j-1,i) )               &
-              +      (           ibit23 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j+3,i) + w(k,j-2,i) )               &
+          flux_n(k) = v_comp(k) * (                                            &
+                     ( 37.0_wp * ibit23 * adv_mom_5                            &
+                  +     7.0_wp * ibit22 * adv_mom_3                            &
+                  +              ibit21 * adv_mom_1                            &
+                     ) *                                                       &
+                                    ( w(k,j+1,i) + w(k,j,i)   )                &
+              -      (  8.0_wp * ibit23 * adv_mom_5                            &
+                  +              ibit22 * adv_mom_3                            &
+                     ) *                                                       &
+                                    ( w(k,j+2,i) + w(k,j-1,i) )                &
+              +      (           ibit23 * adv_mom_5                            &
+                     ) *                                                       &
+                                    ( w(k,j+3,i) + w(k,j-2,i) )                &
                                   )
 
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit23 * adv_mom_5                           &
-                  +     3.0_wp * ibit22 * adv_mom_3                           &
-                  +              ibit21 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j+1,i) - w(k,j,i)   )               &
-              -      (  5.0_wp * ibit23 * adv_mom_5                           &
-                  +              ibit22 * adv_mom_3                           &
-                     ) *                                                      &
-                                   ( w(k,j+2,i)  - w(k,j-1,i) )               &
-              +      (           ibit23 * adv_mom_5                           &
-                     ) *                                                      &
-                                   ( w(k,j+3,i)  - w(k,j-2,i) )               &
+          diss_n(k) = - ABS( v_comp(k) ) * (                                   &
+                     ( 10.0_wp * ibit23 * adv_mom_5                            &
+                  +     3.0_wp * ibit22 * adv_mom_3                            &
+                  +              ibit21 * adv_mom_1                            &
+                     ) *                                                       &
+                                    ( w(k,j+1,i) - w(k,j,i)   )                &
+              -      (  5.0_wp * ibit23 * adv_mom_5                            &
+                  +              ibit22 * adv_mom_3                            &
+                     ) *                                                       &
+                                   ( w(k,j+2,i)  - w(k,j-1,i) )                &
+              +      (           ibit23 * adv_mom_5                            &
+                     ) *                                                       &
+                                   ( w(k,j+3,i)  - w(k,j-2,i) )                &
                                            )
        ENDDO
